/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_QUOTE = 258,
     T_QUOTE2 = 259,
     T_QUOTE3 = 260,
     T_EQUAL = 261,
     T_NOTEQ = 262,
     T_LESSEQ = 263,
     T_GREATEREQ = 264,
     T_QUIT = 265,
     T_WARRANTY = 266,
     T_PRINT = 267,
     T_IPRINT = 268,
     T_PRINTLATEX = 269,
     T_PRINTCSRC = 270,
     T_TIME = 271,
     T_DONOTHING = 272,
     T_SCORE = 273,
     T_COMPLEX_SYMBOLS = 274,
     T_REAL_SYMBOLS = 275,
     T_IMPORTFILE = 276,
     T_SAVE = 277,
     T_STRING = 278,
     T_NUMBER = 279,
     T_SYMBOL = 280,
     T_LITERAL = 281,
     T_DIGITS = 282,
     NEG = 283
   };
#endif
/* Tokens.  */
#define T_QUOTE 258
#define T_QUOTE2 259
#define T_QUOTE3 260
#define T_EQUAL 261
#define T_NOTEQ 262
#define T_LESSEQ 263
#define T_GREATEREQ 264
#define T_QUIT 265
#define T_WARRANTY 266
#define T_PRINT 267
#define T_IPRINT 268
#define T_PRINTLATEX 269
#define T_PRINTCSRC 270
#define T_TIME 271
#define T_DONOTHING 272
#define T_SCORE 273
#define T_COMPLEX_SYMBOLS 274
#define T_REAL_SYMBOLS 275
#define T_IMPORTFILE 276
#define T_SAVE 277
#define T_STRING 278
#define T_NUMBER 279
#define T_SYMBOL 280
#define T_LITERAL 281
#define T_DIGITS 282
#define NEG 283




/* Copy the first part of user declarations.  */
#line 35 "ginsh_parser.yy"

#include "config.h"
#include <string>

#include <ginac/ginac.h>       // symbolic math functions
using namespace GiNaC;


#ifdef HAVE_RUSAGE
#include <sys/resource.h>
#else
#include <ctime>
#endif


#if HAVE_UNISTD_H
#include <sys/types.h>
#include <unistd.h>
#endif

#include <stdexcept>   // deals with errors: exceptions

#include "ginsh.h"     // contains e.g. all definitions of lex function that are used below

#define YYERROR_VERBOSE 1


#ifdef REALLY_HAVE_LIBREADLINE
// Original readline settings
static int orig_completion_append_character;
#if (GINAC_RL_VERSION_MAJOR < 4) || (GINAC_RL_VERSION_MAJOR == 4 && GINAC_RL_VERSION_MINOR < 2)
static char *orig_basic_word_break_characters;
#else
static const char *orig_basic_word_break_characters;
#endif


#if (GINAC_RL_VERSION_MAJOR >= 5)
#define GINAC_RL_COMPLETER_CAST(a) const_cast<char *>((a))
#else
#define GINAC_RL_COMPLETER_CAST(a) (a)
#endif
#endif // REALLY_HAVE_LIBREADLINE



// Expression stack for %, %% and %%%
static void push(const ex &e);
static ex exstack[3];


// Start and end time for the time() function
#ifdef HAVE_RUSAGE
static struct rusage start_time, end_time;
#define START_TIMER getrusage(RUSAGE_SELF, &start_time);
#define STOP_TIMER getrusage(RUSAGE_SELF, &end_time);
#define PRINT_TIME_USED cout << \
   (end_time.ru_utime.tv_sec - start_time.ru_utime.tv_sec) + \
       (end_time.ru_stime.tv_sec - start_time.ru_stime.tv_sec) + \
       double(end_time.ru_utime.tv_usec - start_time.ru_utime.tv_usec) / 1e6 + \
       double(end_time.ru_stime.tv_usec - start_time.ru_stime.tv_usec) / 1e6 \
                       << 's' << endl;
#else
static std::clock_t start_time, end_time;
#define START_TIMER start_time = std::clock();
#define STOP_TIMER end_time = std::clock();
#define PRINT_TIME_USED \
  cout << double(end_time - start_time)/CLOCKS_PER_SEC << 's' << endl;
#endif



// Table of functions 
//
// Table is loaded at start of main()
// 
// (a multimap, because one function may appear with different
// numbers of parameters)
typedef ex   (*fcnp1)(const exprseq &e);                   // non-GiNaC function, taking exprseq as input, defined in ginsh code
typedef ex   (*fcnp2)(const exprseq &e, int serial);       // direct GiNaC function
typedef ex   (*fcnp3)(const char* str, const exprseq &e);  // non-GiNaC function, taking (1 string + exprseq) as input, defined in ginsh code 

struct fcn_desc {
	fcn_desc()                             : p(NULL)       , num_params(0)  , is_ginac(false), serial(0) {}
	fcn_desc(fcnp1 func, int num)          : p((void*)func), num_params(num), is_ginac(false), serial(0) {}
	fcn_desc(fcnp2 func, int num, int ser) : p((void*)func), num_params(num), is_ginac(true) , serial(ser) {}
        fcn_desc(fcnp3 func, int num)          : p((void*)func), num_params(num), is_ginac(false), serial(0) {}

	void *p;	// Pointer to function
	int num_params;	// Number of parameters (0 = arbitrary)
	bool is_ginac;	// Flag: function is GiNaC function
	int serial;	// GiNaC function serial number (if is_ginac == true)
};

typedef multimap<string, fcn_desc> fcn_tab;
static fcn_tab fcns;
static fcn_tab::const_iterator find_function(const ex &sym, int req_params);

// Tables for initializing the "fcns" map and the function help topics
// Note: the 0x0100 flag in num_params is used to indicate what kind of function it is:
//       if flag is 1, then it is a function of type fcnp3
//       if flag is 0, then it is a function of type fcnp1
struct fcn_init {
	const char *name;
	void       *p;
	int         num_params;
};



// Table to map help topics to help strings
typedef multimap<string, string> help_tab;
static help_tab help;

static void insert_fcn_help(const char *name, const char *str);
static void print_help(const string &topic);
static void print_help_topics(void);



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 282 "ginsh_parser.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   438

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  49
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  10
/* YYNRULES -- Number of rules.  */
#define YYNRULES  74
/* YYNRULES -- Number of states.  */
#define YYNSTATES  144

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   283

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    37,     2,     2,     2,     2,     2,    44,
      40,    41,    33,    31,    43,    32,     2,    34,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    39,    38,
      29,    28,    30,    42,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    47,     2,    48,    36,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    45,     2,    46,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    35
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    12,    15,    21,    27,
      33,    39,    42,    45,    48,    51,    54,    56,    58,    60,
      62,    63,    70,    73,    78,    87,    94,   101,   104,   107,
     109,   111,   114,   117,   120,   122,   124,   128,   130,   132,
     134,   136,   138,   142,   147,   152,   159,   163,   167,   171,
     175,   179,   183,   187,   191,   195,   199,   203,   207,   210,
     213,   217,   220,   224,   228,   232,   234,   238,   239,   241,
     243,   247,   251,   257,   259
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      50,     0,    -1,    -1,    50,    51,    -1,    38,    -1,    53,
      38,    -1,    53,    39,    -1,    12,    40,    53,    41,    38,
      -1,    13,    40,    53,    41,    38,    -1,    14,    40,    53,
      41,    38,    -1,    15,    40,    53,    41,    38,    -1,    42,
      12,    -1,    42,    13,    -1,    42,    14,    -1,    42,    15,
      -1,    42,    42,    -1,    10,    -1,    11,    -1,    17,    -1,
      18,    -1,    -1,    16,    52,    40,    53,    41,    38,    -1,
      42,    16,    -1,    21,    40,    23,    41,    -1,    22,    40,
      23,    43,    23,    43,    53,    41,    -1,    22,    40,    23,
      43,    23,    41,    -1,    22,    40,    23,    43,    53,    41,
      -1,    42,    21,    -1,    42,    22,    -1,    20,    -1,    19,
      -1,    42,    25,    -1,     1,    38,    -1,     1,    39,    -1,
      24,    -1,    25,    -1,    44,    25,    44,    -1,    26,    -1,
      27,    -1,     3,    -1,     4,    -1,     5,    -1,    25,    40,
      41,    -1,    25,    40,    54,    41,    -1,    25,    40,    23,
      41,    -1,    25,    40,    23,    43,    54,    41,    -1,    27,
      28,    24,    -1,    25,    28,    53,    -1,    53,     6,    53,
      -1,    53,     7,    53,    -1,    53,    29,    53,    -1,    53,
       8,    53,    -1,    53,    30,    53,    -1,    53,     9,    53,
      -1,    53,    31,    53,    -1,    53,    32,    53,    -1,    53,
      33,    53,    -1,    53,    34,    53,    -1,    32,    53,    -1,
      31,    53,    -1,    53,    36,    53,    -1,    53,    37,    -1,
      40,    53,    41,    -1,    45,    55,    46,    -1,    47,    57,
      48,    -1,    53,    -1,    54,    43,    53,    -1,    -1,    56,
      -1,    53,    -1,    56,    43,    53,    -1,    47,    58,    48,
      -1,    57,    43,    47,    58,    48,    -1,    53,    -1,    58,
      43,    53,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   202,   202,   203,   206,   207,   216,   226,   234,   248,
     256,   264,   265,   266,   267,   270,   271,   272,   285,   286,
     289,   289,   290,   293,   303,   315,   326,   338,   339,   342,
     346,   350,   353,   354,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   373,   382,   391,   400,   401,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   425,   426,   429,   430,   433,
     434,   437,   438,   441,   442
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_QUOTE", "T_QUOTE2", "T_QUOTE3",
  "T_EQUAL", "T_NOTEQ", "T_LESSEQ", "T_GREATEREQ", "T_QUIT", "T_WARRANTY",
  "T_PRINT", "T_IPRINT", "T_PRINTLATEX", "T_PRINTCSRC", "T_TIME",
  "T_DONOTHING", "T_SCORE", "T_COMPLEX_SYMBOLS", "T_REAL_SYMBOLS",
  "T_IMPORTFILE", "T_SAVE", "T_STRING", "T_NUMBER", "T_SYMBOL",
  "T_LITERAL", "T_DIGITS", "'='", "'<'", "'>'", "'+'", "'-'", "'*'", "'/'",
  "NEG", "'^'", "'!'", "';'", "':'", "'('", "')'", "'?'", "','", "'''",
  "'{'", "'}'", "'['", "']'", "$accept", "input", "line", "@1", "exp",
  "exprseq", "list_or_empty", "list", "matrixrows", "row", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,    61,    60,
      62,    43,    45,    42,    47,   283,    94,    33,    59,    58,
      40,    41,    63,    44,    39,   123,   125,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    49,    50,    50,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      52,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    53,    53,    53,    53,    53,    53,
      53,    53,    53,    53,    53,    53,    53,    53,    53,    53,
      53,    53,    53,    53,    53,    53,    53,    53,    53,    53,
      53,    53,    53,    53,    53,    54,    54,    55,    55,    56,
      56,    57,    57,    58,    58
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     2,     2,     5,     5,     5,
       5,     2,     2,     2,     2,     2,     1,     1,     1,     1,
       0,     6,     2,     4,     8,     6,     6,     2,     2,     1,
       1,     2,     2,     2,     1,     1,     3,     1,     1,     1,
       1,     1,     3,     4,     4,     6,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       3,     2,     3,     3,     3,     1,     3,     0,     1,     1,
       3,     3,     5,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     0,    39,    40,    41,    16,    17,     0,
       0,     0,     0,    20,    18,    19,    30,    29,     0,     0,
      34,    35,    37,    38,     0,     0,     4,     0,     0,     0,
      67,     0,     3,     0,    32,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    59,    58,     0,    11,
      12,    13,    14,    22,    27,    28,    31,    15,     0,    69,
       0,    68,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    61,     5,     6,     0,     0,
       0,     0,     0,     0,     0,    47,     0,    42,    65,     0,
      46,    62,    36,    63,     0,    73,     0,     0,    64,    48,
      49,    51,    53,    50,    52,    54,    55,    56,    57,    60,
       0,     0,     0,     0,     0,    23,     0,    44,     0,    43,
       0,    70,     0,    71,     0,     7,     8,     9,    10,     0,
       0,     0,     0,    66,    74,     0,    21,    25,     0,    26,
      45,    72,     0,    24
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,    32,    40,    88,    89,    60,    61,    63,    96
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -37
static const yytype_int16 yypact[] =
{
     -37,    86,   -37,   -17,   -37,   -37,   -37,   -37,   -37,   -31,
      -7,     1,     7,   -37,   -37,   -37,   -37,   -37,    10,    11,
     -37,   -22,   -37,   -12,   176,   176,   -37,   176,   -11,    33,
     176,    15,   -37,    46,   -37,   -37,   176,   176,   176,   176,
      34,    65,    69,   176,   131,    70,     3,     3,   203,   -37,
     -37,   -37,   -37,   -37,   -37,   -37,   -37,   -37,    51,   401,
      63,    71,   176,   -36,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   -37,   -37,   -37,   218,   254,
     267,   303,   176,    75,    77,   401,   -24,   -37,   401,   -16,
     -37,   -37,   -37,   -37,   176,   401,   -35,    78,   -37,   284,
     284,    12,    12,    12,    12,    23,    23,     3,     3,     3,
      84,    89,    91,    94,   316,   -37,   142,   -37,   176,   -37,
     176,   401,   176,   -37,   176,   -37,   -37,   -37,   -37,   100,
     -13,   352,    -9,   401,   401,   -28,   -37,   -37,   176,   -37,
     -37,   -37,   365,   -37
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -37,   -37,   -37,   -37,    -1,    21,   -37,   -37,   -37,    16
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      33,    49,    50,    51,    52,    53,    43,    97,   122,    36,
      54,    55,    98,   123,    56,   122,    45,   117,    44,   118,
     141,    34,    35,    46,    47,   119,    48,   120,   137,    59,
     138,    57,   140,    37,   120,    78,    79,    80,    81,    74,
      75,    38,    85,    70,    71,    72,    73,    39,    74,    75,
      41,    42,    64,    65,    66,    67,    72,    73,    58,    74,
      75,    95,    62,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,    82,    68,    69,    70,    71,    72,
      73,   114,    74,    75,    76,    77,     2,     3,    83,     4,
       5,     6,    84,   121,    90,    92,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    93,
      20,    21,    22,    23,    94,   131,   115,    24,    25,   133,
     116,   134,   125,    95,    26,   124,    27,   126,    28,   127,
      29,    30,   128,    31,     4,     5,     6,   142,   136,   132,
     135,     0,     0,     0,     0,     4,     5,     6,     0,     0,
       0,     0,     0,     0,    86,    20,    21,    22,    23,     0,
       0,     0,    24,    25,     0,   130,    20,    21,    22,    23,
       0,    27,    87,    24,    25,    29,    30,     0,    31,     4,
       5,     6,    27,     0,     0,     0,    29,    30,     0,    31,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      20,    21,    22,    23,     0,     0,     0,    24,    25,    64,
      65,    66,    67,     0,     0,     0,    27,     0,     0,     0,
      29,    30,     0,    31,    64,    65,    66,    67,     0,     0,
       0,     0,    68,    69,    70,    71,    72,    73,     0,    74,
      75,     0,     0,     0,    91,     0,     0,    68,    69,    70,
      71,    72,    73,     0,    74,    75,     0,     0,     0,   110,
      64,    65,    66,    67,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    64,    65,    66,    67,     0,     0,     0,
       0,     0,     0,    68,    69,    70,    71,    72,    73,     0,
      74,    75,    66,    67,     0,   111,    68,    69,    70,    71,
      72,    73,     0,    74,    75,     0,     0,     0,   112,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,     0,
      74,    75,    64,    65,    66,    67,     0,     0,     0,     0,
       0,     0,    68,    69,    70,    71,    72,    73,     0,    74,
      75,     0,     0,     0,   113,    68,    69,    70,    71,    72,
      73,     0,    74,    75,     0,     0,     0,   129,    64,    65,
      66,    67,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    64,    65,    66,    67,     0,     0,     0,     0,     0,
       0,    68,    69,    70,    71,    72,    73,     0,    74,    75,
       0,     0,     0,   139,    68,    69,    70,    71,    72,    73,
       0,    74,    75,     0,     0,     0,   143,    64,    65,    66,
      67,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      68,    69,    70,    71,    72,    73,     0,    74,    75
};

static const yytype_int16 yycheck[] =
{
       1,    12,    13,    14,    15,    16,    28,    43,    43,    40,
      21,    22,    48,    48,    25,    43,    28,    41,    40,    43,
      48,    38,    39,    24,    25,    41,    27,    43,    41,    30,
      43,    42,    41,    40,    43,    36,    37,    38,    39,    36,
      37,    40,    43,    31,    32,    33,    34,    40,    36,    37,
      40,    40,     6,     7,     8,     9,    33,    34,    25,    36,
      37,    62,    47,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    40,    29,    30,    31,    32,    33,
      34,    82,    36,    37,    38,    39,     0,     1,    23,     3,
       4,     5,    23,    94,    24,    44,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    46,
      24,    25,    26,    27,    43,   116,    41,    31,    32,   120,
      43,   122,    38,   124,    38,    47,    40,    38,    42,    38,
      44,    45,    38,    47,     3,     4,     5,   138,    38,   118,
     124,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    -1,
      -1,    -1,    31,    32,    -1,    23,    24,    25,    26,    27,
      -1,    40,    41,    31,    32,    44,    45,    -1,    47,     3,
       4,     5,    40,    -1,    -1,    -1,    44,    45,    -1,    47,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      24,    25,    26,    27,    -1,    -1,    -1,    31,    32,     6,
       7,     8,     9,    -1,    -1,    -1,    40,    -1,    -1,    -1,
      44,    45,    -1,    47,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    29,    30,    31,    32,    33,    34,    -1,    36,
      37,    -1,    -1,    -1,    41,    -1,    -1,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    -1,    -1,    -1,    41,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    -1,    29,    30,    31,    32,    33,    34,    -1,
      36,    37,     8,     9,    -1,    41,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    -1,    -1,    -1,    41,     6,
       7,     8,     9,    29,    30,    31,    32,    33,    34,    -1,
      36,    37,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
      -1,    -1,    29,    30,    31,    32,    33,    34,    -1,    36,
      37,    -1,    -1,    -1,    41,    29,    30,    31,    32,    33,
      34,    -1,    36,    37,    -1,    -1,    -1,    41,     6,     7,
       8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,
      -1,    29,    30,    31,    32,    33,    34,    -1,    36,    37,
      -1,    -1,    -1,    41,    29,    30,    31,    32,    33,    34,
      -1,    36,    37,    -1,    -1,    -1,    41,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      29,    30,    31,    32,    33,    34,    -1,    36,    37
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    50,     0,     1,     3,     4,     5,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      24,    25,    26,    27,    31,    32,    38,    40,    42,    44,
      45,    47,    51,    53,    38,    39,    40,    40,    40,    40,
      52,    40,    40,    28,    40,    28,    53,    53,    53,    12,
      13,    14,    15,    16,    21,    22,    25,    42,    25,    53,
      55,    56,    47,    57,     6,     7,     8,     9,    29,    30,
      31,    32,    33,    34,    36,    37,    38,    39,    53,    53,
      53,    53,    40,    23,    23,    53,    23,    41,    53,    54,
      24,    41,    44,    46,    43,    53,    58,    43,    48,    53,
      53,    53,    53,    53,    53,    53,    53,    53,    53,    53,
      41,    41,    41,    41,    53,    41,    43,    41,    43,    41,
      43,    53,    43,    48,    47,    38,    38,    38,    38,    41,
      23,    53,    54,    53,    53,    58,    38,    41,    43,    41,
      41,    48,    53,    41
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 207 "ginsh_parser.yy"
    {
		try {
			cout << (yyvsp[(1) - (2)].expression) << endl << endl;
			push((yyvsp[(1) - (2)].expression));
		} catch (exception &e) {
			cerr << e.what() << endl;
			YYERROR;
		}
	}
    break;

  case 6:
#line 216 "ginsh_parser.yy"
    {
		try {
			push((yyvsp[(1) - (2)].expression));  // no output to screen
		} catch (exception &e) {
			cerr << e.what() << endl;
			YYERROR;
		}
	}
    break;

  case 7:
#line 226 "ginsh_parser.yy"
    {
		try {
			(yyvsp[(3) - (5)].expression).print(print_tree(std::cout));
		} catch (exception &e) {
			cerr << e.what() << endl;
			YYERROR;
		}
	}
    break;

  case 8:
#line 234 "ginsh_parser.yy"
    {
		try {
			ex e = (yyvsp[(3) - (5)].expression);
			if (!e.info(info_flags::integer))
				throw (std::invalid_argument("argument to iprint() must be an integer"));
			long i = ex_to<numeric>(e).to_long();
			cout << i << endl;
			cout << "#o" << oct << i << endl;
			cout << "#x" << hex << i << dec << endl;
		} catch (exception &e) {
			cerr << e.what() << endl;
			YYERROR;
		}
	}
    break;

  case 9:
#line 248 "ginsh_parser.yy"
    {
		try {
			(yyvsp[(3) - (5)].expression).print(print_latex(std::cout)); cout << endl;
		} catch (exception &e) {
			std::cerr << e.what() << endl;
			YYERROR;
		}
	}
    break;

  case 10:
#line 256 "ginsh_parser.yy"
    {
		try {
			(yyvsp[(3) - (5)].expression).print(print_csrc_double(std::cout)); cout << endl;
		} catch (exception &e) {
			std::cerr << e.what() << endl;
			YYERROR;
		}
	}
    break;

  case 11:
#line 264 "ginsh_parser.yy"
    {print_help("print");}
    break;

  case 12:
#line 265 "ginsh_parser.yy"
    {print_help("iprint");}
    break;

  case 13:
#line 266 "ginsh_parser.yy"
    {print_help("print_latex");}
    break;

  case 14:
#line 267 "ginsh_parser.yy"
    {print_help("print_csrc");}
    break;

  case 15:
#line 270 "ginsh_parser.yy"
    {print_help_topics();}
    break;

  case 16:
#line 271 "ginsh_parser.yy"
    {YYACCEPT;}
    break;

  case 17:
#line 272 "ginsh_parser.yy"
    {
		cout << "  This program is free software; you can redistribute it and/or modify it under\n";
		cout << "  the terms of the GNU General Public License as published by the Free Software\n";
		cout << "  Foundation; either version 2 of the License, or (at your option) any later\n";
		cout << "  version.\n";
		cout << "  This program is distributed in the hope that it will be useful, but WITHOUT\n";
		cout << "  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS\n";
		cout << "  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more\n";
		cout << "  details.\n";
		cout << "  You should have received a copy of the GNU General Public License along with\n";
		cout << "  this program. If not, write to the Free Software Foundation, 675 Mass Ave,\n";
		cout << "  Cambridge, MA 02139, USA.\n\n";
	}
    break;

  case 18:
#line 285 "ginsh_parser.yy"
    {cout << "Nothing happens.\n";}
    break;

  case 19:
#line 286 "ginsh_parser.yy"
    {
		cout << "Number of symbols defined up to now is " << syms.size() << endl;
	}
    break;

  case 20:
#line 289 "ginsh_parser.yy"
    { START_TIMER }
    break;

  case 21:
#line 289 "ginsh_parser.yy"
    {STOP_TIMER PRINT_TIME_USED }
    break;

  case 22:
#line 290 "ginsh_parser.yy"
    {print_help("time");}
    break;

  case 23:
#line 293 "ginsh_parser.yy"
    {
                FILE *pFile;
                pFile = fopen((yyvsp[(3) - (4)].inputstring), "r");
                if (pFile != NULL) {
			cout << "--- Reading file: <" << (yyvsp[(3) - (4)].inputstring) << ">" << endl;
          		yyrestart(pFile);
                } else {
                	cerr << "Opening file <" << (yyvsp[(3) - (4)].inputstring) << "> failed..." << endl;
                }
        }
    break;

  case 24:
#line 303 "ginsh_parser.yy"
    {
                ofstream File;
                File.open((yyvsp[(3) - (8)].inputstring), ofstream::out | ofstream::app);
                if (File.is_open()) {
			File << (yyvsp[(5) - (8)].inputstring);
			File << (yyvsp[(7) - (8)].expression) << ";" << endl;
			File.close();
			cout << "Wrote to file <" << (yyvsp[(3) - (8)].inputstring) << ">: \""  << (yyvsp[(5) - (8)].inputstring) << (yyvsp[(7) - (8)].expression) << ";\"" << endl << endl;
                } else {
                	cerr << "Opening file <" << (yyvsp[(3) - (8)].inputstring) << "> failed..." << endl;
                }
	}
    break;

  case 25:
#line 315 "ginsh_parser.yy"
    {
                ofstream File;
                File.open((yyvsp[(3) - (6)].inputstring), ofstream::out | ofstream::app);
                if (File.is_open()) {
			File << (yyvsp[(5) - (6)].inputstring) << endl;
			File.close();
			cout << "Wrote to file <" << (yyvsp[(3) - (6)].inputstring) << ">: \""  << (yyvsp[(5) - (6)].inputstring) << "\"" << endl << endl;
                } else {
                	cerr << "Opening file <" << (yyvsp[(3) - (6)].inputstring) << "> failed..." << endl;
                }
	}
    break;

  case 26:
#line 326 "ginsh_parser.yy"
    {
                ofstream File;
                File.open((yyvsp[(3) - (6)].inputstring), ofstream::out | ofstream::app);
                if (File.is_open()) {
			File << (yyvsp[(5) - (6)].expression) << ";" << endl;
			File.close();
			cout << "Wrote to file <" << (yyvsp[(3) - (6)].inputstring) << ">: \""  << (yyvsp[(5) - (6)].expression) << ";\"" << endl << endl;
                } else {
                	cerr << "Opening file <" << (yyvsp[(3) - (6)].inputstring) << "> failed..." << endl;
                }
	}
    break;

  case 27:
#line 338 "ginsh_parser.yy"
    {print_help("importfile");}
    break;

  case 28:
#line 339 "ginsh_parser.yy"
    {print_help("save");}
    break;

  case 29:
#line 342 "ginsh_parser.yy"
    { 
 		cout << "  All new symbols introduced from now on are assumed to be real." << endl;
		symboltype = domain::real; 
	}
    break;

  case 30:
#line 346 "ginsh_parser.yy"
    { 
 		cout << "  All new symbols introduced from now on are assumed to be complex." << endl;
		symboltype = domain::complex; 
	}
    break;

  case 31:
#line 350 "ginsh_parser.yy"
    {print_help(ex_to<symbol>((yyvsp[(2) - (2)].expression)).get_name());}
    break;

  case 32:
#line 353 "ginsh_parser.yy"
    {yyclearin; yyerrok;}
    break;

  case 33:
#line 354 "ginsh_parser.yy"
    {yyclearin; yyerrok;}
    break;

  case 34:
#line 357 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (1)].expression);}
    break;

  case 35:
#line 358 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (1)].expression).eval();}
    break;

  case 36:
#line 359 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(2) - (3)].expression);}
    break;

  case 37:
#line 360 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (1)].expression);}
    break;

  case 38:
#line 361 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (1)].expression);}
    break;

  case 39:
#line 362 "ginsh_parser.yy"
    {(yyval.expression) = exstack[0];}
    break;

  case 40:
#line 363 "ginsh_parser.yy"
    {(yyval.expression) = exstack[1];}
    break;

  case 41:
#line 364 "ginsh_parser.yy"
    {(yyval.expression) = exstack[2];}
    break;

  case 42:
#line 365 "ginsh_parser.yy"
    {                                              // function()   (without arguments)
		fcn_tab::const_iterator i = find_function((yyvsp[(1) - (3)].expression), 0);
		if (i->second.is_ginac) {
                        (yyval.expression) = ((fcnp2)(i->second.p))(ex_to<exprseq>(0), i->second.serial);
		} else {
			(yyval.expression) = ((fcnp1)(i->second.p))(ex_to<exprseq>(0));   // there are no arguments so pass on 0 as exprseq
		}
	}
    break;

  case 43:
#line 373 "ginsh_parser.yy"
    {                                      // function(...)
		fcn_tab::const_iterator i = find_function((yyvsp[(1) - (4)].expression), (yyvsp[(3) - (4)].expression).nops());
		if (i->second.is_ginac) {
			(yyval.expression) = ((fcnp2)(i->second.p))(ex_to<exprseq>((yyvsp[(3) - (4)].expression)), i->second.serial);
		} else {
			(yyval.expression) = ((fcnp1)(i->second.p))(ex_to<exprseq>((yyvsp[(3) - (4)].expression)));
		}
	}
    break;

  case 44:
#line 382 "ginsh_parser.yy"
    {                                     // function("...")
		fcn_tab::const_iterator i = find_function((yyvsp[(1) - (4)].expression), 0x0100);    // 0x0100 flag indicates that the first argument is a strings
		if (i->second.is_ginac) {
 			throw(std::logic_error("This should not happen - GiNaC does not have functions taking strings"));
		} else {
			(yyval.expression) = ((fcnp3)(i->second.p))((yyvsp[(3) - (4)].inputstring), ex_to<exprseq>(0));  // argument gets passed on as a string!
		}
	}
    break;

  case 45:
#line 391 "ginsh_parser.yy"
    {                                 // function("...", ...)
		fcn_tab::const_iterator i = find_function((yyvsp[(1) - (6)].expression), 0x0100+(yyvsp[(5) - (6)].expression).nops());  // 0x0100 flag indicates that the first argument is a strings
		if (i->second.is_ginac) {
 			throw(std::logic_error("This should not happen - GiNaC does not have functions taking strings"));
		} else {
			(yyval.expression) = ((fcnp3)(i->second.p))((yyvsp[(3) - (6)].inputstring), ex_to<exprseq>((yyvsp[(5) - (6)].expression)));  // argument gets passed on as a string!
		}
	}
    break;

  case 46:
#line 400 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(3) - (3)].expression); Digits = ex_to<numeric>((yyvsp[(3) - (3)].expression)).to_int();}
    break;

  case 47:
#line 401 "ginsh_parser.yy"
    {
		(yyval.expression) = (yyvsp[(3) - (3)].expression); 
		if (yyin != stdin) cout << "> " << (yyvsp[(1) - (3)].expression) << " = " << endl;    // also output first part of line
		const_cast<symbol&>(ex_to<symbol>((yyvsp[(1) - (3)].expression))).assign((yyvsp[(3) - (3)].expression));         // essential line: assigns something to a symbol
        }
    break;

  case 48:
#line 406 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (3)].expression) == (yyvsp[(3) - (3)].expression);}
    break;

  case 49:
#line 407 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (3)].expression) != (yyvsp[(3) - (3)].expression);}
    break;

  case 50:
#line 408 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (3)].expression) < (yyvsp[(3) - (3)].expression);}
    break;

  case 51:
#line 409 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (3)].expression) <= (yyvsp[(3) - (3)].expression);}
    break;

  case 52:
#line 410 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (3)].expression) > (yyvsp[(3) - (3)].expression);}
    break;

  case 53:
#line 411 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (3)].expression) >= (yyvsp[(3) - (3)].expression);}
    break;

  case 54:
#line 412 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (3)].expression) + (yyvsp[(3) - (3)].expression);}
    break;

  case 55:
#line 413 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (3)].expression) - (yyvsp[(3) - (3)].expression);}
    break;

  case 56:
#line 414 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (3)].expression) * (yyvsp[(3) - (3)].expression);}
    break;

  case 57:
#line 415 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (3)].expression) / (yyvsp[(3) - (3)].expression);}
    break;

  case 58:
#line 416 "ginsh_parser.yy"
    {(yyval.expression) = -(yyvsp[(2) - (2)].expression);}
    break;

  case 59:
#line 417 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(2) - (2)].expression);}
    break;

  case 60:
#line 418 "ginsh_parser.yy"
    {(yyval.expression) = power((yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression));}
    break;

  case 61:
#line 419 "ginsh_parser.yy"
    {(yyval.expression) = factorial((yyvsp[(1) - (2)].expression));}
    break;

  case 62:
#line 420 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(2) - (3)].expression);}
    break;

  case 63:
#line 421 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(2) - (3)].expression);}
    break;

  case 64:
#line 422 "ginsh_parser.yy"
    {(yyval.expression) = lst_to_matrix(ex_to<lst>((yyvsp[(2) - (3)].expression)));}
    break;

  case 65:
#line 425 "ginsh_parser.yy"
    {(yyval.expression) = exprseq((yyvsp[(1) - (1)].expression));}
    break;

  case 66:
#line 426 "ginsh_parser.yy"
    {exprseq es(ex_to<exprseq>((yyvsp[(1) - (3)].expression))); (yyval.expression) = es.append((yyvsp[(3) - (3)].expression));}
    break;

  case 67:
#line 429 "ginsh_parser.yy"
    {(yyval.expression) = *new lst;}
    break;

  case 68:
#line 430 "ginsh_parser.yy"
    {(yyval.expression) = (yyvsp[(1) - (1)].expression);}
    break;

  case 69:
#line 433 "ginsh_parser.yy"
    {(yyval.expression) = lst((yyvsp[(1) - (1)].expression));}
    break;

  case 70:
#line 434 "ginsh_parser.yy"
    {lst l(ex_to<lst>((yyvsp[(1) - (3)].expression))); (yyval.expression) = l.append((yyvsp[(3) - (3)].expression));}
    break;

  case 71:
#line 437 "ginsh_parser.yy"
    {(yyval.expression) = lst((yyvsp[(2) - (3)].expression));}
    break;

  case 72:
#line 438 "ginsh_parser.yy"
    {lst l(ex_to<lst>((yyvsp[(1) - (5)].expression))); (yyval.expression) = l.append((yyvsp[(4) - (5)].expression));}
    break;

  case 73:
#line 441 "ginsh_parser.yy"
    {(yyval.expression) = lst((yyvsp[(1) - (1)].expression));}
    break;

  case 74:
#line 442 "ginsh_parser.yy"
    {lst l(ex_to<lst>((yyvsp[(1) - (3)].expression))); (yyval.expression) = l.append((yyvsp[(3) - (3)].expression));}
    break;


/* Line 1267 of yacc.c.  */
#line 2148 "ginsh_parser.cc"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 450 "ginsh_parser.yy"

// Error print routine
// Is called by yyparse() whenever an error occurs...
int yyerror(char *s)
{
	cerr << s << " at " << yytext << endl;
	return 0;
}

// Push expression "e" onto the expression stack (for ", "" and """)
static void push(const ex &e)
{
	exstack[2] = exstack[1];
	exstack[1] = exstack[0];
	exstack[0] = e;
}


/*
 *  Built-in functions
 */

static ex f_collect(const exprseq &e) {return e[0].collect(e[1]);}
static ex f_collect_distributed(const exprseq &e) {return e[0].collect(e[1], true);}
static ex f_collect_common_factors(const exprseq &e) {return collect_common_factors(e[0]);}
static ex f_convert_H_to_Li(const exprseq &e) {return convert_H_to_Li(e[0], e[1]);}
static ex f_degree(const exprseq &e) {return e[0].degree(e[1]);}
static ex f_denom(const exprseq &e) {return e[0].denom();}
static ex f_eval1(const exprseq &e) {return e[0].eval();}
static ex f_evalf1(const exprseq &e) {return e[0].evalf();}
static ex f_eval_integ(const exprseq &e) {return e[0].eval_integ();}
static ex f_expand(const exprseq &e) {return e[0].expand();}
static ex f_gcd(const exprseq &e) {return gcd(e[0], e[1]);}
static ex f_has(const exprseq &e) {return e[0].has(e[1]) ? ex(1) : ex(0);}
static ex f_lcm(const exprseq &e) {return lcm(e[0], e[1]);}
static ex f_lcoeff(const exprseq &e) {return e[0].lcoeff(e[1]);}
static ex f_ldegree(const exprseq &e) {return e[0].ldegree(e[1]);}
static ex f_lsolve(const exprseq &e) {return lsolve(e[0], e[1]);}
static ex f_nops(const exprseq &e) {return e[0].nops();}
static ex f_normal1(const exprseq &e) {return e[0].normal();}
static ex f_numer(const exprseq &e) {return e[0].numer();}
static ex f_numer_denom(const exprseq &e) {return e[0].numer_denom();}
static ex f_pow(const exprseq &e) {return pow(e[0], e[1]);}
static ex f_sqrt(const exprseq &e) {return sqrt(e[0]);}
static ex f_sqrfree1(const exprseq &e) {return sqrfree(e[0]);}
static ex f_subs2(const exprseq &e) {return e[0].subs(e[1]);}
static ex f_tcoeff(const exprseq &e) {return e[0].tcoeff(e[1]);}

#define CHECK_ARG(num, type, fcn) if (!is_a<type>(e[num])) throw(std::invalid_argument("Error: Argument " #num " to " #fcn "() must be a " #type))

static ex f_charpoly(const exprseq &e)
{
	CHECK_ARG(0, matrix, charpoly);
	return ex_to<matrix>(e[0]).charpoly(e[1]);
}

static ex f_coeff(const exprseq &e)
{
	CHECK_ARG(2, numeric, coeff);
	return e[0].coeff(e[1], ex_to<numeric>(e[2]).to_int());
}

static ex f_content(const exprseq &e)
{
	return e[0].content(e[1]);
}

static ex f_decomp_rational(const exprseq &e)
{
	return decomp_rational(e[0], e[1]);
}

static ex f_determinant(const exprseq &e)
{
	CHECK_ARG(0, matrix, determinant);
	return ex_to<matrix>(e[0]).determinant();
}

static ex f_diag(const exprseq &e)
{
	size_t dim = e.nops();
	matrix &m = *new matrix(dim, dim);
	for (size_t i=0; i<dim; i++)
		m.set(i, i, e.op(i));
	return m;
}

static ex f_diff2(const exprseq &e)
{
	CHECK_ARG(1, symbol, diff);
	return e[0].diff(ex_to<symbol>(e[1]));
}

static ex f_diff3(const exprseq &e)
{
	CHECK_ARG(1, symbol, diff);
	CHECK_ARG(2, numeric, diff);
	return e[0].diff(ex_to<symbol>(e[1]), ex_to<numeric>(e[2]).to_int());
}

static ex f_divide(const exprseq &e)
{
	ex q;
	if (divide(e[0], e[1], q))
		return q;
	else
		return fail();
}

static ex f_eval2(const exprseq &e)
{
	CHECK_ARG(1, numeric, eval);
	return e[0].eval(ex_to<numeric>(e[1]).to_int());
}

static ex f_evalf2(const exprseq &e)
{
	CHECK_ARG(1, numeric, evalf);
	return e[0].evalf(ex_to<numeric>(e[1]).to_int());
}

static ex f_evalm(const exprseq &e) 
{	
	if (ex_to<matrix>(e[0].evalm()).rows() == 1 && ex_to<matrix>(e[0].evalm()).cols() == 1) {
		return (ex_to<matrix>(e[0].evalm()))(0,0);  // 1 by 1 matrix is a number
	} else {	
		return  e[0].evalm();
 	}
}

static ex f_find(const exprseq &e)
{
	lst found;
	e[0].find(e[1], found);
	return found;
}

static ex f_fsolve(const exprseq &e)
{
	CHECK_ARG(1, symbol, fsolve);
	CHECK_ARG(2, numeric, fsolve);
	CHECK_ARG(3, numeric, fsolve);
	return fsolve(e[0], ex_to<symbol>(e[1]), ex_to<numeric>(e[2]), ex_to<numeric>(e[3]));
}

static ex f_integer_content(const exprseq &e)
{
	return e[0].expand().integer_content();
}

static ex f_integral(const exprseq &e)
{
	CHECK_ARG(0, symbol, integral);
	return integral(e[0], e[1], e[2], e[3]);
}

static ex f_inverse(const exprseq &e)
{
	CHECK_ARG(0, matrix, inverse);
	return ex_to<matrix>(e[0]).inverse();
}

static ex f_is(const exprseq &e)
{
	CHECK_ARG(0, relational, is);
	return (bool)ex_to<relational>(e[0]) ? ex(1) : ex(0);
}

class apply_map_function : public map_function {
	ex apply;
public:
	apply_map_function(const ex & a) : apply(a) {}
	virtual ~apply_map_function() {}
	ex operator()(const ex & e) { return apply.subs(wild() == e, true); }
};

static ex f_map(const exprseq &e)
{
	apply_map_function fcn(e[1]);
	return e[0].map(fcn);
}

static ex f_match(const exprseq &e)
{
	lst repl_lst;
	if (e[0].match(e[1], repl_lst))
		return repl_lst;
	else
		return fail();
}

static ex f_normal2(const exprseq &e)
{
	CHECK_ARG(1, numeric, normal);
	return e[0].normal(ex_to<numeric>(e[1]).to_int());
}

static ex f_op(const exprseq &e)
{
	CHECK_ARG(1, numeric, op);
	int n = ex_to<numeric>(e[1]).to_int();
	if (n < 0 || n >= (int)e[0].nops())
		throw(std::out_of_range("second argument to op() is out of range"));
	return e[0].op(n);
}

static ex f_prem(const exprseq &e)
{
	return prem(e[0], e[1], e[2]);
}

static ex f_primpart(const exprseq &e)
{
	return e[0].primpart(e[1]);
}

static ex f_quo(const exprseq &e)
{
	return quo(e[0], e[1], e[2]);
}

static ex f_rank(const exprseq &e)
{
	CHECK_ARG(0, matrix, rank);
	return ex_to<matrix>(e[0]).rank();
}

static ex f_rem(const exprseq &e)
{
	return rem(e[0], e[1], e[2]);
}

static ex f_resultant(const exprseq &e)
{
	CHECK_ARG(2, symbol, resultant);
	return resultant(e[0], e[1], ex_to<symbol>(e[2]));
}

static ex f_series(const exprseq &e)
{
	CHECK_ARG(2, numeric, series);
	return e[0].series(e[1], ex_to<numeric>(e[2]).to_int());
}

static ex f_sprem(const exprseq &e)
{
	return sprem(e[0], e[1], e[2]);
}

static ex f_sqrfree2(const exprseq &e)
{
	CHECK_ARG(1, lst, sqrfree);
	return sqrfree(e[0], ex_to<lst>(e[1]));
}

static ex f_subs3(const exprseq &e)
{
	CHECK_ARG(1, lst, subs);
	CHECK_ARG(2, lst, subs);
	return e[0].subs(ex_to<lst>(e[1]), ex_to<lst>(e[2]));
}

static ex f_trace(const exprseq &e)
{
	CHECK_ARG(0, matrix, trace);
	return ex_to<matrix>(e[0]).trace();
}

static ex f_transpose(const exprseq &e)
{
	CHECK_ARG(0, matrix, transpose);
	return ex_to<matrix>(e[0]).transpose();
}

static ex f_unassign(const exprseq &e)
{
	CHECK_ARG(0, symbol, unassign);
	const_cast<symbol&>(ex_to<symbol>(e[0])).unassign();
	return e[0];
}

static ex f_unit(const exprseq &e)
{
	return e[0].unit(e[1]);
}

static ex f_dummy(const exprseq &e)
{
	throw(std::logic_error("dummy function called (shouldn't happen)"));
}

static const fcn_init builtin_fcns[] = {
	{"charpoly",               (void*)f_charpoly, 2},
	{"coeff",                  (void*)f_coeff, 3},
	{"collect",                (void*)f_collect, 2},
	{"collect_common_factors", (void*)f_collect_common_factors, 1},
	{"collect_distributed",    (void*)f_collect_distributed, 2},
	{"content",                (void*)f_content, 2},
	{"convert_H_to_Li",        (void*)f_convert_H_to_Li, 2},
	{"decomp_rational",        (void*)f_decomp_rational, 2},
	{"degree",                 (void*)f_degree, 2},
	{"denom",                  (void*)f_denom, 1},
	{"determinant",            (void*)f_determinant, 1},
	{"diag",                   (void*)f_diag, 0},
	{"diff",                   (void*)f_diff2, 2},
	{"diff",                   (void*)f_diff3, 3},
	{"divide",                 (void*)f_divide, 2},
	{"eval",                   (void*)f_eval1, 1},
	{"eval",                   (void*)f_eval2, 2},
	{"evalf",                  (void*)f_evalf1, 1},
	{"evalf",                  (void*)f_evalf2, 2},
	{"evalm",                  (void*)f_evalm, 1},
	{"eval_integ",             (void*)f_eval_integ, 1},
	{"expand",                 (void*)f_expand, 1},
	{"find",                   (void*)f_find, 2},
	{"fsolve",                 (void*)f_fsolve, 4},
	{"gcd",                    (void*)f_gcd, 2},
	{"has",                    (void*)f_has, 2},
	{"integer_content",        (void*)f_integer_content, 1},
	{"integral",               (void*)f_integral, 4},
	{"inverse",                (void*)f_inverse, 1},
	{"importfile",             (void*)f_dummy, 0},      // for Tab-completion
	{"iprint",                 (void*)f_dummy, 0},      // for Tab-completion
	{"is",                     (void*)f_is, 1},
	{"lcm",                    (void*)f_lcm, 2},
	{"lcoeff",                 (void*)f_lcoeff, 2},
	{"ldegree",                (void*)f_ldegree, 2},
	{"lsolve",                 (void*)f_lsolve, 2},
	{"map",                    (void*)f_map, 2},
	{"match",                  (void*)f_match, 2},
	{"nops",                   (void*)f_nops, 1},
	{"normal",                 (void*)f_normal1, 1},
	{"normal",                 (void*)f_normal2, 2},
	{"numer",                  (void*)f_numer, 1},
	{"numer_denom",            (void*)f_numer_denom, 1},
	{"op",                     (void*)f_op, 2},
	{"pow",                    (void*)f_pow, 2},
	{"prem",                   (void*)f_prem, 3},
	{"primpart",               (void*)f_primpart, 2},
	{"print",                  (void*)f_dummy, 0},      // for Tab-completion
	{"print_csrc",             (void*)f_dummy, 0},      // for Tab-completion
	{"print_latex",            (void*)f_dummy, 0},      // for Tab-completion
	{"quo",                    (void*)f_quo, 3},
	{"rank",                   (void*)f_rank, 1},
	{"rem",                    (void*)f_rem, 3},
	{"resultant",              (void*)f_resultant, 3},
	{"save",                   (void*)f_dummy, 0},      // for Tab-completion
	{"series",                 (void*)f_series, 3},
	{"sprem",                  (void*)f_sprem, 3},
	{"sqrfree",                (void*)f_sqrfree1, 1},
	{"sqrfree",                (void*)f_sqrfree2, 2},
	{"sqrt",                   (void*)f_sqrt, 1},
	{"subs",                   (void*)f_subs2, 2},
	{"subs",                   (void*)f_subs3, 3},
	{"tcoeff",                 (void*)f_tcoeff, 2},
	{"time",                   (void*)f_dummy, 0},        // for Tab-completion
	{"trace",                  (void*)f_trace, 1},
	{"transpose",              (void*)f_transpose, 1},
	{"unassign",               (void*)f_unassign, 1},
	{"unit",                   (void*)f_unit, 2},
	{NULL,                     (void*)f_dummy, 0}           // End marker
};

struct fcn_help_init {
	const char *name;
	const char *help;
};

static const fcn_help_init builtin_help[] = {
	{"acos", "inverse cosine function"},
	{"acosh", "inverse hyperbolic cosine function"},
	{"asin", "inverse sine function"},
	{"asinh", "inverse hyperbolic sine function"},
	{"atan", "inverse tangent function"},
	{"atan2", "inverse tangent function with two arguments"},
	{"atanh", "inverse hyperbolic tangent function"},
	{"beta", "Beta function"},
	{"binomial", "binomial function"},
	{"cos", "cosine function"},
	{"cosh", "hyperbolic cosine function"},
	{"exp", "exponential function"},
	{"factorial", "factorial function"},
	{"lgamma", "natural logarithm of Gamma function"},
	{"tgamma", "Gamma function"},
	{"log", "natural logarithm"},
	{"psi", "psi function\npsi(x) is the digamma function, psi(n,x) the nth polygamma function"},
	{"sin", "sine function"},
	{"sinh", "hyperbolic sine function"},
	{"tan", "tangent function"},
	{"tanh", "hyperbolic tangent function"},
	{"zeta", "zeta function\nzeta(x) is Riemann's zeta function, zetaderiv(n,x) its nth derivative.\nIf x is a GiNaC::lst, it is a multiple zeta value\nzeta(x,s) is an alternating Euler sum"},
	{"Li2", "dilogarithm"},
	{"Li3", "trilogarithm"},
	{"Li", "(multiple) polylogarithm"},
	{"S", "Nielsen's generalized polylogarithm"},
	{"H", "harmonic polylogarithm"},
	{"Order", "order term function (for truncated power series)"},
	{"Derivative", "inert differential operator"},
	{NULL, NULL}	// End marker
};

#include "ginsh_extensions.h"

/*
 *  Add functions to ginsh
 */

// Functions from fcn_init array
static void insert_fcns(const fcn_init *p)
{
	while (p->name) {
		if (p->num_params & 0x0100){   
        		fcns.insert(make_pair(string(p->name), fcn_desc((fcnp3)(p->p), p->num_params)));
		} else {
        		fcns.insert(make_pair(string(p->name), fcn_desc((fcnp1)(p->p), p->num_params)));
                }
		p++;
	}
}

static ex f_ginac_function(const exprseq &es, int serial)
{
	return function(serial, es).eval(1);
}

// All registered GiNaC functions
namespace GiNaC {
void ginsh_get_ginac_functions(void)
{
	vector<function_options>::const_iterator i = function::registered_functions().begin(), end = function::registered_functions().end();
	unsigned serial = 0;
	while (i != end) {
		fcns.insert(make_pair(i->get_name(), fcn_desc(f_ginac_function, i->get_nparams(), serial)));
		++i;
		serial++;
	}
}
}


/*
 *  Find a function given a name and number of parameters. Throw exceptions on error.
 */

static fcn_tab::const_iterator find_function(const ex &sym, int req_params)
{
	int errNumber = 0;

	const string &name = ex_to<symbol>(sym).get_name();
	typedef fcn_tab::const_iterator I;
	pair<I, I> b = fcns.equal_range(name);        // search for function with name in fcns list

	if (b.first == b.second)                      // could not find function
		throw(std::logic_error("unknown function '" + name + "'"));
	else {                                        // matching function(s) found in fcns list
		errNumber = 1;
		int FcnMatch_num_params;
		int FcnMatch_flag;
		int FcnInput_num_params = req_params & (~0x0100);
		int FcnInput_flag       = req_params & ( 0x0100); 
		for (I i=b.first; i!=b.second; i++){  // if many functions found try all matches
			FcnMatch_num_params = i->second.num_params & (~0x0100);
			FcnMatch_flag       = i->second.num_params & ( 0x0100);
			if (  (FcnMatch_num_params == 0                   && FcnMatch_flag       == FcnInput_flag) 
                            ||(FcnMatch_num_params == FcnInput_num_params && FcnMatch_flag       == FcnInput_flag)){
				errNumber = 0;
				return i;
			}
                        if (  (FcnMatch_num_params == FcnInput_num_params && FcnMatch_flag       != FcnInput_flag)){
				if (FcnInput_flag == 0x0100)
 					errNumber = 2;
				else 
 					errNumber = 3;	
 			}
                }
	}
	if (errNumber == 1)          // function name was found but number of arguments was incorrect
		throw(std::logic_error("invalid number of arguments to " + name + "()"));
        else if (errNumber == 2)     // function name was found, number of arguments matched but function did not expect a string as input
		throw(std::logic_error("syntax error, expected an expression as argument of " + name + "()"));
        else if (errNumber == 3)     // function name was found, number of arguments matched but function did not expect an expresion as input
		throw(std::logic_error("syntax error, expected a string as argument of " + name + "()"));
		
}


/*
 *  Insert help strings
 */

// Normal help string
static void insert_help(const char *topic, const char *str)
{
	help.insert(make_pair(string(topic), string(str)));
}

// Help string for functions, automatically generates synopsis
static void insert_fcn_help(const char *name, const char *str)
{
	typedef fcn_tab::const_iterator I;
	pair<I, I> b = fcns.equal_range(name);
	if (b.first != b.second) {
		string help_str = string(name) + "(";

		// if flag is set, first argument is a string
   		if ((b.first->second.num_params & (0x0100)) == 0x0100){
			help_str += "string";
			if ((b.first->second.num_params & (~0x0100)) != 0)
				help_str += ", ";
		}

		for (int i=0; i < (b.first->second.num_params & (~0x0100)); i++) {
			if (i != 0) help_str += ", ";
			help_str += "expression";
		}
		help_str += ")\n";
		help_str += str;
		help.insert(make_pair(string(name), help_str));
	}
}

// Help strings for functions from fcn_help_init array
static void insert_help(const fcn_help_init *p)
{
	while (p->name) {
		insert_fcn_help(p->name, p->help);
		p++;
	}
}


/*
 *  Print help to cout
 */

// Help for a given topic
static void print_help(const string &topic)
{
	typedef help_tab::const_iterator I;
	pair<I, I> b = help.equal_range(topic);
	if (b.first == b.second)
		cout << "no help for '" << topic << "'\n\n";
	else {
		for (I i=b.first; i!=b.second; i++)
			cout << i->second << endl << endl;
	}
}

// List of help topics
static void print_help_topics(void)
{
	cout << "Available help topics:\n";
	help_tab::const_iterator i;
	string last_name = string("*");
	int num = 0;
	for (i=help.begin(); i!=help.end(); i++) {
		// Don't print duplicates
		if (i->first != last_name) {
			if (num)
				cout << ", ";
			num++;
			cout << i->first;
			last_name = i->first;
		}
	}
	cout << "\nTo get help for a certain topic, type ?topic\n\n";
}


/*
 *  Function name completion functions for readline
 */

static char *fcn_generator(const char *text, int state)
{
	static int len;				// Length of word to complete
	static fcn_tab::const_iterator index;	// Iterator to function being currently considered

	// If this is a new word to complete, initialize now
	if (state == 0) {
		index = fcns.begin();
		len = strlen(text);
	}

	// Return the next function which partially matches
	while (index != fcns.end()) {
		const char *fcn_name = index->first.c_str();
		++index;
		if (strncmp(fcn_name, text, len) == 0)
			return strdup(fcn_name);
	}
	return NULL;
}

#ifdef REALLY_HAVE_LIBREADLINE
static char **fcn_completion(const char *text, int start, int end)
{
	if (rl_line_buffer[0] == '!') {
		// For shell commands, revert back to filename completion
		rl_completion_append_character = orig_completion_append_character;
		rl_basic_word_break_characters = orig_basic_word_break_characters;
		rl_completer_word_break_characters = GINAC_RL_COMPLETER_CAST(rl_basic_word_break_characters);
#if (GINAC_RL_VERSION_MAJOR < 4) || (GINAC_RL_VERSION_MAJOR == 4 && GINAC_RL_VERSION_MINOR < 2)
		return completion_matches(const_cast<char *>(text), (CPFunction *)filename_completion_function);
#else
		return rl_completion_matches(text, rl_filename_completion_function);
#endif
	} else {
		// Otherwise, complete function names
		rl_completion_append_character = '(';
		rl_basic_word_break_characters = " \t\n\"#$%&'()*+,-./:;<=>?@[\\]^`{|}~";
		rl_completer_word_break_characters = GINAC_RL_COMPLETER_CAST(rl_basic_word_break_characters);
#if (GINAC_RL_VERSION_MAJOR < 4) || (GINAC_RL_VERSION_MAJOR == 4 && GINAC_RL_VERSION_MINOR < 2)
		return completion_matches(const_cast<char *>(text), (CPFunction *)fcn_generator);
#else
		return rl_completion_matches(text, fcn_generator);
#endif
	}
}
#endif // REALLY_HAVE_LIBREADLINE

void greeting(void)
{
    cout << "+------------------------------------------------------------------------+" << endl; 
    cout << "| Vscape (V" << VERSION << ")                                                        |" << endl;
    cout << "| Copyright (C) 2007 Korneel  van den Broek.                             |" << endl;
    cout << "|                                                                        |" << endl;
    cout << "| This is free software with ABSOLUTELY NO WARRANTY. You are welcome to  |" << endl; 
    cout << "| redistribute it under certain conditions. For details type 'warranty;' |" << endl;
    cout << "|                                                                        |" << endl;
    cout << "| Type ?? for a list of help topics.                                     |" << endl;
    cout << "+------------------------------------------------------------------------+" << endl; 
    cout << endl;
}

/*
 *  Main program
 */

int main(int argc, char **argv)
{
	// Print banner in interactive mode
	if (isatty(0)) 
		greeting();

 	// Init things associated with external extensions
	init_external();

 	// Init function table
	insert_fcns(builtin_fcns);
	insert_fcns(extended_fcns);
	insert_fcns(Vscape_fcns);
	ginsh_get_ginac_functions();

	// Init help for operators (automatically generated from man page)
	insert_help("operators", "Operators in falling order of precedence:");
#include "ginsh_op_help.h"

	// Init help for built-in functions (automatically generated from man page)
#include "ginsh_fcn_help.h"

        /* Help */
	// Help for GiNaC functions is added manually
	insert_help(builtin_help);    
	insert_help(extended_help);
	insert_help(Vscape_help);

	// Help for other keywords
	insert_help("print",       "print(expression) \ndumps the internal structure of the given expression (for debugging)");
	insert_help("iprint",      "iprint(expression) \nprints the given integer expression in decimal, octal, and hexadecimal bases");
	insert_help("print_latex", "print_latex(expression) \nprints a LaTeX representation of the given expression");
	insert_help("print_csrc",  "print_csrc(expression) \nprints a C source code representation of the given expression");
	insert_help("importfile",  "importfile(\"filename\") \nread commands from \"filename\"");
	insert_help("save",        "save(\"filename\" [, \"string\"] [,expression]) \nopen \"filename\" and append the string and/or expression to the end of the file");

  
        /* Command completion */
#ifdef REALLY_HAVE_LIBREADLINE
	// Init readline completer
	rl_readline_name = argv[0];
#if (GINAC_RL_VERSION_MAJOR < 4) || (GINAC_RL_VERSION_MAJOR == 4 && GINAC_RL_VERSION_MINOR < 2)
	rl_attempted_completion_function = (CPPFunction *)fcn_completion;
#else
	rl_attempted_completion_function = fcn_completion;
#endif
	orig_completion_append_character = rl_completion_append_character;
	orig_basic_word_break_characters = rl_basic_word_break_characters;
#endif


        /* Initialize input source */
	// Init input file list, open first file
	num_files = argc - 1;
	file_list = argv + 1;
	if (num_files) {
		yyin = fopen(*file_list, "r");
		if (yyin == NULL) {
			cerr << "Can't open " << *file_list << endl;
			exit(1);
		} else {
			cout << "--- Reading file: <" << *file_list << ">" << endl;
                }
		num_files--;
		file_list++;
	}


        /* Start Parsing input */
	// Parse input, catch all remaining exceptions
	int result;
again:	try {
		result = yyparse();
	} catch (exception &e) {
		cerr << e.what() << endl;
		goto again;
	}

	exit_external();
  	
	return result;
}

